diff --git a/krita/ui/canvas/kis_projection_backend.h b/krita/ui/canvas/kis_projection_backend.h
index 6465b6b..a8abf40 100644
--- a/krita/ui/canvas/kis_projection_backend.h
+++ b/krita/ui/canvas/kis_projection_backend.h
@@ -19,14 +19,11 @@
 #ifndef KIS_PROJECTION_BACKEND
 #define KIS_PROJECTION_BACKEND
 
-#include <QPainter>
-#include <QImage>
-#include <QSize>
-#include <QRect>
-#include <kis_types.h>
+#include "kis_update_info.h"
 
 class KoColorProfile;
-struct KisImagePatch;
+class UpdateInformation;
+class KisImagePatch;
 
 /**
  * KisProjectionBackend ia an abstract class represinting
@@ -48,9 +45,19 @@ public:
     virtual void setMonitorProfile(const KoColorProfile* monitorProfile) = 0;
 
     /**
-     * Updates @rc (in KisImage pixels) from the base image
+     * Updates the cache of the backend by reading from
+     * an accociated image. All data transfers with
+     * KisImage should happen here
      */
-    virtual void setDirty(const QRect& rc) = 0;
+    virtual void updateCache(KisPPUpdateInfoSP info) = 0;
+
+    /**
+     * Prescales the cache of the backend. It is intended to be
+     * called from a separate thread where you can easily
+     * do the calculations. No data transfers with KisImage
+     * should happen during this phase
+     */
+    virtual void recalculateCache(KisPPUpdateInfoSP info) = 0;
 
     /**
      * Some backends cannot work with arbitrary areas due to
@@ -60,105 +67,30 @@ public:
     virtual void alignSourceRect(QRect& rect, qreal scale);
 
     /**
-     * Get a patch from a backend that can draw a @requestedRect on some
-     * QPainter in future. @scaleX and @scaleY are the scales of planned
-     * drawing, btw, it doesn't mean that an QImage inside the patch will
-     * have these scales - it'll have the nearest suitable scale or even
-     * original scale (e.g. KisProjectionCache)
+     * Gets a patch from a backend that can draw a info.imageRect on some
+     * QPainter in future. info.scaleX and info.scaleY are the scales
+     * of planned drawing, btw, it doesn't mean that an QImage inside
+     * the patch will have these scales - it'll have the nearest suitable
+     * scale or even original scale (e.g. KisProjectionCache)
      *
-     * If @borderWidth is non-zero, @requestedRect will be axpended by
-     * @borderWidth pixels to all directions and image of this rect will
-     * actually be written to the patch's QImage. That is done to eliminate
-     * border effects in smooth scaling.
+     * If info.borderWidth is non-zero, info.requestedRect will
+     * be axpended by info.borderWidth pixels to all directions and
+     * image of this rect will actually be written to the patch's QImage.
+     * That is done to eliminate border effects in smooth scaling.
      */
-    virtual KisImagePatch getNearestPatch(qreal scaleX, qreal scaleY,
-                                          const QRect& requestedRect,
-                                          qint32 borderWidth) = 0;
+    virtual KisImagePatch getNearestPatch(KisPPUpdateInfoSP info) = 0;
 
     /**
      * Draws a piece of original image onto @gc's canvas
-     * @imageRect - area in KisImage pixels where to read from
-     * @viewportRect - area in canvas pixels where to write to
-     * If @imageRect and @viewportRect don't agree, the image
+     * @param info.imageRect - area in KisImage pixels where to read from
+     * @param info.viewportRect - area in canvas pixels where to write to
+     * If info.imageRect and info.viewportRect don't agree, the image
      * will be scaled
-     * @borderWidth has the same meaning as in getNearestPatch
-     * @renderHints - hints, transmitted to QPainter during darwing
+     * @param info.borderWidth has the same meaning as in getNearestPatch
+     * @param info.renderHints - hints, transmitted to QPainter during darwing
      */
     virtual void drawFromOriginalImage(QPainter& gc,
-                                       const QRect& imageRect,
-                                       const QRectF& viewportRect,
-                                       qint32 borderWidth,
-                                       QPainter::RenderHints renderHints) = 0;
-};
-
-
-struct KisImagePatch {
-    /**
-     * The scale of the image stored in the patch
-     */
-    qreal m_scaleX;
-    qreal m_scaleY;
-
-    /**
-     * The rect of KisImage covered by the image
-     * of the patch (in KisImage pixels)
-     */
-    QRect m_patchRect;
-
-    /**
-     * The rect that was requested during creation
-     * of the patch. It equals to patchRect withount
-     * borders
-     * These borders are introdused for more accurate
-     * smooth scaling to reduce border effects
-     * (IN m_image PIXELS, relative to m_image's topLeft);
-
-     */
-    QRectF m_interestRect;
-
-    QImage m_image;
-
-    /**
-     * Darws an m_interestRect of the patch onto @gc
-     * By the way it fits this rect into @dstRect
-     * @renderHints are directly tranmitted to QPainter
-     */
-    void drawMe(QPainter &gc,
-                const QRectF &dstRect,
-                QPainter::RenderHints renderHints);
-
-    /**
-     * Prescales an interestRect a bit with Blitz
-     * It's usefulness is dispulable and should be
-     * tested, so - FIXME
-     */
-    void prescaleWithBlitz(QRectF dstRect);
+                                       KisPPUpdateInfoSP info) = 0;
 };
 
-inline void scaleRect(QRectF &rc, qreal scaleX, qreal scaleY)
-{
-    qreal x, y, w, h;
-    rc.getRect(&x, &y, &w, &h);
-
-    x *= scaleX;
-    y *= scaleY;
-    w *= scaleX;
-    h *= scaleY;
-
-    rc.setRect(x, y, w, h);
-}
-
-inline void scaleRect(QRect &rc, qreal scaleX, qreal scaleY)
-{
-    qint32 x, y, w, h;
-    rc.getRect(&x, &y, &w, &h);
-
-    x *= scaleX;
-    y *= scaleY;
-    w *= scaleX;
-    h *= scaleY;
-
-    rc.setRect(x, y, w, h);
-}
-
 #endif /* KIS_PROJECTION_BACKEND */
diff --git a/krita/ui/canvas/kis_projection_cache.cpp b/krita/ui/canvas/kis_projection_cache.cpp
index 84cb8a9..99ecb9a 100644
--- a/krita/ui/canvas/kis_projection_cache.cpp
+++ b/krita/ui/canvas/kis_projection_cache.cpp
@@ -19,13 +19,8 @@
 #include <KoColorProfile.h>
 
 #include "kis_projection_cache.h"
-#include "kis_config.h"
 #include <kis_image.h>
 
-// for toAlignedRectWorkaround()
-#include "kis_prescaled_projection.h"
-
-
 KisProjectionCache::KisProjectionCache()
         : m_cacheKisImageAsQImage(true)
         , m_monitorProfile(0)
@@ -49,7 +44,7 @@ void KisProjectionCache::setCacheKisImageAsQImage(bool toggle)
     if (toggle != m_cacheKisImageAsQImage) {
         if (toggle) {
             m_cacheKisImageAsQImage = true;
-            setDirty(QRect(0, 0, m_imageSize.width(), m_imageSize.height()));
+            updateCachedQImage(QRect(0, 0, m_imageSize.width(), m_imageSize.height()));
         } else {
             m_cacheKisImageAsQImage = false;
             m_unscaledCache = QImage();
@@ -76,7 +71,12 @@ void KisProjectionCache::setImageSize(qint32 w,  qint32 h)
 #endif
 
         m_unscaledCache = QImage(w, h, QImage::Format_ARGB32);
-        setDirty(QRect(0, 0, w, h));
+        /**
+         * FIXME: Check why not use m_image->bounds()
+         * instead of QRect(0, 0, w, h)
+         */
+        if (m_cacheKisImageAsQImage)
+            updateCachedQImage(QRect(0, 0, w, h));
 
 #ifndef ALWAYS_CACHE_AS_QIMAGE
     }
@@ -88,100 +88,79 @@ void KisProjectionCache::setMonitorProfile(const KoColorProfile* monitorProfile)
     m_monitorProfile = monitorProfile;
 }
 
-void KisProjectionCache::setDirty(const QRect & rc)
+void KisProjectionCache::updateCache(KisPPUpdateInfoSP info)
 {
-
-
     if (!m_image) return;
-    if (!m_cacheKisImageAsQImage) return;
-
-    if (m_unscaledCache.isNull()) {
-
-        m_unscaledCache = QImage(m_image->width(), m_image->height(), QImage::Format_ARGB32);
-
+    if (m_cacheKisImageAsQImage) {
+        updateCachedQImage(info->dirtyImageRect);
     }
+    else {
+        /**
+         * We can neither draw the image directly from the KisImage
+         * nor cache it in the internal QImage.
+         * The only way out left is to create a patch and store
+         * a dirty piece of image there
+         */
+        info->transfer = KisPPUpdateInfo::DIRECT;
+        info->patch = getNearestPatch(info);
+    }
+}
 
-    QPainter p(&m_unscaledCache);
-    p.setCompositionMode(QPainter::CompositionMode_Source);
-
-    QImage updateImage = m_image->convertToQImage(rc.x(), rc.y(), rc.width(), rc.height(),
-                         m_monitorProfile);
-
-//     if (m_showMask && m_drawMaskVisualisationOnUnscaledCanvasCache) {
-//
-//         // XXX: Also visualize the global selection
-//
-//         KisSelectionSP selection = 0;
-//
-//         if (m_currentNode) {
-//             if (m_currentNode->inherits("KisMask")) {
-//
-//                 selection = dynamic_cast<const KisMask*>(m_currentNode.data())->selection();
-//             } else if (m_currentNode->inherits("KisLayer")) {
-//
-//                 KisLayerSP layer = dynamic_cast<KisLayer*>(m_currentNode.data());
-//                 if (KisSelectionMaskSP selectionMask = layer->selectionMask()) {
-//                     selection = selectionMask->selection();
-//                 }
-//             }
-//         }
-//         selection->paint(&updateImage, rc);
-//     }
-
-
-    p.drawImage(rc.x(), rc.y(), updateImage, 0, 0, rc.width(), rc.height());
-    p.end();
-
+void KisProjectionCache::recalculateCache(KisPPUpdateInfoSP info)
+{
+    Q_UNUSED(info);
+    /* nothing to do, happily */
 }
-#include <QtDebug>
-KisImagePatch KisProjectionCache::getNearestPatch(qreal scaleX, qreal scaleY,
-        const QRect& requestedRect,
-        qint32 borderWidth)
+
+void KisProjectionCache::updateCachedQImage(const QRect &rect)
 {
-    Q_UNUSED(scaleX);
-    Q_UNUSED(scaleY);
-    KisImagePatch patch;
+    if (m_unscaledCache.isNull())
+        m_unscaledCache = QImage(m_image->width(), m_image->height(), QImage::Format_ARGB32);
 
-    patch.m_scaleX = 1.;
-    patch.m_scaleY = 1.;
+    QPainter gc(&m_unscaledCache);
+    gc.setCompositionMode(QPainter::CompositionMode_Source);
 
-    patch.m_interestRect = toFloatRectWorkaround(
-                               QRect(borderWidth, borderWidth,
-                                     requestedRect.width(),
-                                     requestedRect.height())
-                           );
+    QImage updateImage = m_image->convertToQImage(rect,
+                                                  m_monitorProfile);
 
-    QRect adjustedRect = requestedRect.adjusted(-borderWidth, -borderWidth,
-                         borderWidth, borderWidth);
-    patch.m_patchRect = adjustedRect;
+    gc.drawImage(rect.x(), rect.y(),
+                 updateImage, 0, 0,
+                 rect.width(), rect.height());
+    gc.end();
+}
 
-    if (m_cacheKisImageAsQImage) {
-        patch.m_image = m_unscaledCache.copy(patch.m_patchRect);
-    } else {
-        qint32 x, y, w, h;
-        patch.m_patchRect.getRect(&x, &y, &w, &h);
+KisImagePatch KisProjectionCache::getNearestPatch(KisPPUpdateInfoSP info)
+{
+    KisImagePatch patch(info->imageRect, info->borderWidth, 1., 1.);
 
-        patch.m_image = m_image->convertToQImage(x, y, w, h,
-                        m_monitorProfile);
-    }
+    if (m_cacheKisImageAsQImage)
+        patch.setImage(m_unscaledCache.copy(patch.patchRect()));
+    else
+        patch.setImage(m_image->convertToQImage(patch.patchRect(),
+                                                m_monitorProfile));
 
     return patch;
 }
 
-void KisProjectionCache::drawFromOriginalImage(QPainter& gc,
-        const QRect& imageRect,
-        const QRectF& viewportRect,
-        qint32 borderWidth,
-        QPainter::RenderHints renderHints)
+void KisProjectionCache::drawFromOriginalImage(QPainter& gc, KisPPUpdateInfoSP info)
 {
     if (m_cacheKisImageAsQImage) {
         gc.save();
         gc.setCompositionMode(QPainter::CompositionMode_Source);
-        gc.setRenderHints(renderHints, true);
-        gc.drawImage(viewportRect, m_unscaledCache, imageRect);
+        gc.setRenderHints(info->renderHints, true);
+        gc.drawImage(info->viewportRect, m_unscaledCache, info->imageRect);
         gc.restore();
     } else {
-        KisImagePatch patch = getNearestPatch(1, 1, imageRect, borderWidth);
-        patch.drawMe(gc, viewportRect, renderHints);
+        /**
+         * FIXME: In case this function is called from preScale() there
+         * will be no patch prepared. It means we need a direct access
+         * to the KisImage's data. That is not really what we wanted
+         * to achieve.
+         */
+        if(!info->patch.isValid()) {
+            info->patch = getNearestPatch(info);
+        }
+
+        info->patch.drawMe(gc, info->viewportRect, info->renderHints);
     }
 }
diff --git a/krita/ui/canvas/kis_projection_cache.h b/krita/ui/canvas/kis_projection_cache.h
index 19be1df..ef5e908 100644
--- a/krita/ui/canvas/kis_projection_cache.h
+++ b/krita/ui/canvas/kis_projection_cache.h
@@ -20,11 +20,6 @@
 #ifndef KIS_PROJECTION_CACHE
 #define KIS_PROJECTION_CACHE
 
-#include <QImage>
-#include <QSize>
-#include <QRect>
-#include <kis_types.h>
-
 #include "kis_projection_backend.h"
 
 /**
@@ -42,20 +37,16 @@ public:
     void setImage(KisImageWSP image);
     void setImageSize(qint32 w, qint32 h);
     void setMonitorProfile(const KoColorProfile* monitorProfile);
-    void setDirty(const QRect& rc);
-
-    KisImagePatch getNearestPatch(qreal scaleX, qreal scaleY,
-                                  const QRect& requestedRect,
-                                  qint32 borderWidth);
+    void updateCache(KisPPUpdateInfoSP info);
+    void recalculateCache(KisPPUpdateInfoSP info);
 
-    void drawFromOriginalImage(QPainter& gc,
-                               const QRect& imageRect,
-                               const QRectF& viewportRect,
-                               qint32 borderWidth,
-                               QPainter::RenderHints renderHints);
+    KisImagePatch getNearestPatch(KisPPUpdateInfoSP info);
+    void drawFromOriginalImage(QPainter& gc, KisPPUpdateInfoSP info);
 
     void setCacheKisImageAsQImage(bool toggle);
 
+private:
+    void updateCachedQImage(const QRect &rect);
 
 private:
 
diff --git a/krita/ui/canvas/kis_qpainter_canvas.cpp b/krita/ui/canvas/kis_qpainter_canvas.cpp
index 2e3d4dc..20feb0f 100644
--- a/krita/ui/canvas/kis_qpainter_canvas.cpp
+++ b/krita/ui/canvas/kis_qpainter_canvas.cpp
@@ -151,10 +151,10 @@ void KisQPainterCanvas::paintEvent(QPaintEvent * ev)
             gc.fillRect(fillRect, m_d->checkBrush);
         }
     }
-        
+
     if(canvas()->image()->rootLayer()->childCount()>0) {
         gc.setCompositionMode(QPainter::CompositionMode_SourceOver);
-    
+
         gc.save();
         if (canvas()->isCanvasMirrored()){
             QTransform m = gc.transform();
@@ -164,14 +164,15 @@ void KisQPainterCanvas::paintEvent(QPaintEvent * ev)
             m.translate( -documentOrigin().x(), 0);
             gc.setTransform(m);
         }
-            if (cfg.noXRender()) {
-                gc.drawPixmap(ev->rect(), m_d->prescaledProjection->prescaledPixmap(), 
-                            ev->rect().translated(-documentOrigin()));
-            } else {
+//            if (cfg.noXRender()) {
+//                gc.drawPixmap(ev->rect(), m_d->prescaledProjection->prescaledPixmap(), 
+//                            ev->rect().translated(-documentOrigin()));
+//            } else {
                 gc.drawImage(ev->rect(), m_d->prescaledProjection->prescaledQImage(), 
                             ev->rect().translated(-documentOrigin()));
-            }
+//            }
     }
+
 #ifdef DEBUG_REPAINT
     QColor color = QColor(random() % 255, random() % 255, random() % 255, 150);
     gc.fillRect(ev->rect(), color);
@@ -276,6 +277,12 @@ void KisQPainterCanvas::slotConfigChanged()
 {
     KisConfig cfg;
 
+    /**
+     * FIXME: Please pay attention to these options:
+     *   - cfg.checkSize();
+     *   - cfg.checkersColor();
+     */
+
     m_d->checkBrush = QBrush(checkImage(cfg.checkSize()));
 }
 
diff --git a/krita/ui/canvas/kis_update_info.cpp b/krita/ui/canvas/kis_update_info.cpp
new file mode 100644
index 0000000..00d6c3a
--- /dev/null
+++ b/krita/ui/canvas/kis_update_info.cpp
@@ -0,0 +1,40 @@
+#include "kis_update_info.h"
+
+/**
+ * The connection in KisCanvas2 uses queued signals
+ * with an argument of KisNodeSP type, so we should
+ * register it beforehand
+ */
+struct KisUpdateInfoSPStaticRegistrar {
+    KisUpdateInfoSPStaticRegistrar() {
+        qRegisterMetaType<KisUpdateInfoSP>("KisUpdateInfoSP");
+    }
+};
+static KisUpdateInfoSPStaticRegistrar __registrar;
+
+KisUpdateInfo::KisUpdateInfo()
+{
+}
+
+KisUpdateInfo::~KisUpdateInfo()
+{
+}
+
+QRect KisUpdateInfo::dirtyViewportRect()
+{
+    return QRect();
+}
+
+QRect KisPPUpdateInfo::dirtyViewportRect() {
+    return viewportRect.toAlignedRect();
+}
+
+
+#ifdef HAVE_OPENGL
+
+QRect KisOpenGLUpdateInfo::dirtyViewportRect() {
+    qFatal("Not implemented yet!");
+    return viewportRect.toAlignedRect();
+}
+
+#endif /* HAVE_OPENGL */
diff --git a/krita/ui/canvas/kis_update_info.h b/krita/ui/canvas/kis_update_info.h
new file mode 100644
index 0000000..4bb5ae3
--- /dev/null
+++ b/krita/ui/canvas/kis_update_info.h
@@ -0,0 +1,114 @@
+/*
+ *  Copyright (c) 2010, Dmitry Kazakov <dimula73@gmail.com>
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
+ */
+
+#ifndef KIS_UPDATE_INFO_H_
+#define KIS_UPDATE_INFO_H_
+
+#include <QPainter>
+#include "kis_shared.h"
+#include "kis_image_patch.h"
+#include <opengl/kis_opengl.h>
+
+
+class KisUpdateInfo;
+class KisPPUpdateInfo;
+typedef KisSharedPtr<KisUpdateInfo> KisUpdateInfoSP;
+typedef KisSharedPtr<KisPPUpdateInfo> KisPPUpdateInfoSP;
+
+
+class KisUpdateInfo : public KisShared
+{
+public:
+    KisUpdateInfo();
+    virtual ~KisUpdateInfo();
+
+    virtual QRect dirtyViewportRect();
+};
+
+Q_DECLARE_METATYPE(KisUpdateInfoSP);
+
+#ifdef HAVE_OPENGL
+#include "opengl/kis_texture_tile_update_info.h"
+
+class KisOpenGLUpdateInfo;
+typedef KisSharedPtr<KisOpenGLUpdateInfo> KisOpenGLUpdateInfoSP;
+
+class KisOpenGLUpdateInfo : public KisUpdateInfo
+{
+public:
+    KisTextureTileUpdateInfoList tileList;
+    QRect dirtyViewportRect();
+
+    QRectF viewportRect;
+};
+#endif /* HAVE_OPENGL */
+
+class KisPPUpdateInfo : public KisUpdateInfo
+{
+public:
+    enum TransferType {
+        DIRECT,
+        PATCH
+    };
+
+    QRect dirtyViewportRect();
+
+    /**
+     * The rect that was reported by KisImage as dirty
+     */
+    QRect dirtyImageRect;
+
+    /**
+     * Rect of KisImage corresponding to @viewportRect.
+     * It is cropped and aligned corresponding to the canvas.
+     */
+    QRect imageRect;
+
+    /**
+     * Rect of canvas widget corresponding to @imageRect
+     */
+    QRectF viewportRect;
+
+    qreal scaleX;
+    qreal scaleY;
+
+    /**
+     * Defines the way the source image is painted onto
+     * prescaled QImage
+     */
+    TransferType transfer;
+
+    /**
+     * Render hints for painting the direct painting/patch painting
+     */
+    QPainter::RenderHints renderHints;
+
+    /**
+     * The number of additional pixels those should be added
+     * to the patch
+     */
+    qint32 borderWidth;
+
+    /**
+     * Used for temporary sorage of KisImage's data
+     * by KisProjectionCache
+     */
+    KisImagePatch patch;
+};
+
+#endif /* KIS_UPDATE_INFO_H_ */
diff --git a/krita/ui/kis_canvas_resource_provider.cpp b/krita/ui/kis_canvas_resource_provider.cpp
index e2fe768..39cab7c 100644
--- a/krita/ui/kis_canvas_resource_provider.cpp
+++ b/krita/ui/kis_canvas_resource_provider.cpp
@@ -104,7 +104,7 @@ void KisCanvasResourceProvider::setHDRExposure(float exposure)
     m_view->image()->projection()->colorSpace()->profile()->setProperty("exposure", exposure);
     m_view->image()->rootLayer()->accept(eV);
     m_view->canvasBase()->updateCanvas();
-    m_view->canvasBase()->updateCanvasProjection(m_view->image()->bounds());
+    m_view->canvasBase()->startUpdateCanvasProjection(m_view->image()->bounds());
 }
 
 
